.test_base:
  stage: test

test:
  extends:
    - .test_base
  script:
    - make test

test race:
  extends:
    - .test_base
  script:
    - make test_race

integration test:
  extends:
    - .test_base
  tags:
    - gitlab-org-docker
  services:
    - name: docker:${DOCKER_VERSION}-dind
      alias: docker
    - name: registry.gitlab.com/gitlab-org/cluster-integration/test-utils/k3s-gitlab-ci/releases/v1.27.1-k3s1
      alias: k3s
  variables:
    FF_NETWORK_PER_BUILD: 1
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - curl --silent -f k3s:8081?service=k3s > kubeconfig
    - export KUBECONFIG=${CI_PROJECT_DIR}/kubeconfig
    - cat ${KUBECONFIG}
    - kubectl version --output yaml
    - kubectl cluster-info
  script:
    - make test_integration

code quality:
  stage: test
  image: golangci/golangci-lint:v1.54.2
  needs: []
  variables:
    REPORT_FILE: gl-code-quality-report.json
    LINT_FLAGS: "--color never --deadline 15m"
    OUT_FORMAT: code-climate
  script:
    - make --silent lint | tee ${REPORT_FILE}
  timeout: 15 minutes
  artifacts:
    reports:
      codequality: ${REPORT_FILE}
    paths:
      - ${REPORT_FILE}
    expire_in: 7d
  cache: {}

docs lint:
  stage: test
  image: registry.gitlab.com/gitlab-org/gitlab-docs:lint
  cache: {}
  dependencies: []
  script:
    - markdownlint --config .markdownlint.json '**/*.md'
  only:
    changes:
      - "**/*.md"
      - .markdownlint.json
